/*
    This program is a very trivial example of a "producer-consumer"
    type of problem. One thread "produces numbers" by incrementing
    a counter. The other thread "consumes numbers" by printing out
    the value of the counter. Look at the output. Can you explain
    why the output looks the way that it does?
*/
#include <windows.h>   // Win32 Sleep()
#include <unistd.h>    // Linux sleep()
#include <stdio.h>
#include "pthread.h"

// global variables
static int runFlag = TRUE;
static int count = 0;

int main( int argc, char *argv[])
{
   //thread function prototypes
   void *thread1(void *vargp);
   void *thread2(void *vargp);

   pthread_t thread1ID;
   pthread_t thread2ID;
   int threadParam1 = 0;  // thread function parameter
   int threadParam2 = 0;

   // create threads
   printf("Starting threads\n");
   pthread_create(&thread1ID, NULL, thread1, &threadParam1);  // should have error checking
   pthread_create(&thread2ID, NULL, thread2, &threadParam2);

   printf("The incrementer is thread number %d.\n", thread1ID);
   printf("The printer is thread number %d.\n", thread2ID);

   Sleep(1000);     // let the threads run for a while
   runFlag = FALSE; // now stop the threads
   Sleep(200);      // give them time to stop
   printf("\nThreads stopped.\n");
   printf("count = %d\n", count);

   return 0;
}//main


void *thread1(void *vargp)
{
   while(runFlag)
   {
      count++;  // produce a number
   }
   return NULL;
}//thread1


void *thread2(void *vargp)
{
   while(runFlag)
   {
      printf("%d ", count);  // consume a number
   }
   return NULL;
}//thread2
