/*
    This program is a very trivial example of a "producer-consumer"
    type of problem. One thread "produces numbers" by incrementing
    a counter. The other thread "consumes numbers" by printing out
    the value of the counter. Look at the output. Can you explain
    why the output looks the way that it does?
*/
#include <windows.h>
#include <stdio.h>

// global variables
static int runFlag = TRUE;
static int count = 0;

int main( int argc, char *argv[])
{
   //thread function prototypes
   DWORD WINAPI thread1(LPVOID);
   DWORD WINAPI thread2(LPVOID);

   DWORD thread1ID;
   DWORD thread2ID;
   int threadParam1 = 0;  // thread function parameter
   int threadParam2 = 0;

   // create threads
   printf("Starting threads\n");
   CreateThread(NULL, 0, thread1, &threadParam1, 0, &thread1ID);
   CreateThread(NULL, 0, thread2, &threadParam2, 0, &thread2ID);

   printf("The incrementer is thread number %d.\n", thread1ID);
   printf("The printer is thread number %d.\n", thread2ID);

   Sleep(1000);     // let the threads run for a while
   runFlag = FALSE; // now stop the threads
   Sleep(200);      // give them time to stop
   printf("\nThreads stopped.\n");
   printf("count = %d\n", count);

   return 0;
}//main


DWORD WINAPI thread1(LPVOID threadParam)
{
   while(runFlag)
   {
      count++;  // produce a number
   }
   return 0;
}//thread1


DWORD WINAPI thread2(LPVOID threadParam)
{
   while(runFlag)
   {
      printf("%d ", count);  // consume a number
   }
   return 0;
}//thread2
